#include<bits/stdc++.h>
using namespace std;
long long l[1000000],r[1000000];
int main()
{
    long long n,q,c;
    string s;
    cin >> n >> c >> q;
    cin >> s;
    for(int i =0;i<q;i++)
    {
        cin >> l[i]>>r[i];
        l[i]--;
        r[i]--;
    }
    for(int i=0;i<q;i++)
    {
        for(int j=l[i];j<=r[i];j++)
        {
            if(s[j]=='1') s[j]='0';
            else s[j]='1';
        }
        long long b=0;
        for(int j=0;j<n;j++)
        {
            if(s[j]=='1') b++;
        }
        long long k=0;
        while(s[k]=='0')
        {
            k++;
        }
        long long k1=n-1;
        while(s[k1]=='0')
        {
            k1--;
        }
        int d = n-b-k-(n-1-k1);
        cout << min(b,c+d)<<endl;
    }
}